/*
 * $Id$
 *
 * [Description ]
 * 
 * Test 0
 */

#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Two_Level_Branch_Predictor/Branch_History_Table/SelfTest/include/test.h"

#define NB_PARAMS 4

void usage (string exec)
{
  cerr << "<Usage> " << exec << " name_instance list_params" << endl
       << "list_params is :" << endl
       << " - size_shifter       (unsigned int)" << endl
       << " - nb_shifter         (unsigned int)" << endl
       << " - nb_prediction      (unsigned int)" << endl
       << " - nb_branch_complete (unsigned int)" << endl;
  exit (1);
}

#ifndef SYSTEMC
int main    (int argc, char * argv[])
#else
int sc_main (int argc, char * argv[])
#endif
{
  if (argc != 2+NB_PARAMS)
    usage (argv[0]);

  const string   name               = argv[1];
  const uint32_t size_shifter       = atoi(argv[2]);
  const uint32_t nb_shifter         = atoi(argv[3]);
  const uint32_t nb_prediction      = atoi(argv[4]);
  const uint32_t nb_branch_complete = atoi(argv[5]);

  morpheo::behavioural::stage_1_ifetch::predictor::meta_predictor::two_level_branch_predictor::branch_history_table::Parameters param (size_shifter       ,
																       nb_shifter         ,
																       nb_prediction      ,
																       nb_branch_complete );

  test (name,param);

  return (EXIT_SUCCESS);
}
